========================================
Release Name: 2.3
Build: 2.3, Version Label: Charles
========================================

What's new in 2.3?
------------------------------------------

1) Jump dialog now filters results as you type.
2) Custom scheme is now implemented as a PN extension.
3) Double-click on tab bar (not on tab) starts a new doc (request #145).
4) 3 types of block comment supported in custom schemes (schemedef).
5) Tags only auto-closed in the correct state in HTML/XML, hr br and img not auto-closed.
6) Miscellaneous updates to schemes to improve highlighting (including HTML5 elements and attributes).
7) RTF export reworked, background colours now working better.
8) Properties scheme folding.
9) Two identifier types in customscheme independant of keyword recognition.
10) Select a URL and right-click to go to it.
11) New German and Russian translations.
12) Scheme Presets: Solarized (Light), improved Obsidian, thanks to contributors.

Bug Fixes:
----------

1) Disable non-relevant project menu items when using magic folders. Fixes issue #1049.
2) Exit code should be 0. Fixes issue #1070.
3) Fix issue leading to crash after closing split view. Fixes issue #1161, #1137, #1301.
4) Allow customizing New Default keyboard shortcut. Allow localising Plain Text scheme name. Fixes issue #1167.
5) More protection for invalid editor scenarios. Fixes issue #1174.
6) Fix window positioning where left-most monitor has negative co-ordinates. Fixes issue #500.
7) Schemes now always rebuilt at install time, remove duplicate Powershell scheme.
8) Fixed an issue where undo didn't correctly clear clip insertion state. Fixes issue #1183.
9) Tools/New/Language menus missing on Chinese Windows XP. Fixes issue #704.
10) Translations not working in Portable distribution. Fixes issue #1220.
11) Auto complete of tags now works when using "ignore case". Fixes issue #1067.
12) Docking window content focused rather than docking window itself, improves behaviour on showing output. Issue #351.
13) Bookmark image now non-aliased. Fixes issue #198.
14) Disable C++ preprocessor tracking.
15) Line comment insertion fixed. Fixes issues #30, #458, #673.
16) Smartstart option serialization. Fixes issue #1316.
17) Jump dialog fixed. Fixes issue #1313.
18) Fix folding. Fixes issue #1284.
19) Remove "-" from PHP character set. Fixes issue #1300.
20) Fix translation of the Page Setup dialog, and several other translation issues. Issues #1307, #1306.
21) Make sure alternate streams and file attributes are retained across saves. Fixes issue #242.
22) Provide a command to return focus to editor at all times, and make sure docking window content is focused on activation. Fixes issue #351.
23) Fix clip indents to avoid breaking multi-line python scripts. Fixes issue #1346.
24) Fix line endings before eval'ing script. Fixes issue #1339.
25) Allow escape to cancel find dialogs. Fixes issues #1074 and #1385.
26) Fixes to the following schemes: Pascal, Modula-2, Matlab, TCL.

What's new in 2.3 under the cover?
------------------------------------------

1) Scintilla updated to 2.23
2) Boost updated to 1.45
3) Now built with Visual Studio 2010


Extensions Interface Changes:
-----------------------------

1) All extensions should be built with Boost 1.45 and VS2010
2) IScriptRunner and IScriptRunner2 merged
3) OpenFile will now switch to an active open window rather than always opening.

========================================
Release Name: 2.2
Build: 2.2, Version Label: ellington
========================================

What's new in 2.2?
------------------------------------------

1) Complete Unicode conversion, files, searching, projects, UI, clips...
2) Complete redesign of text clips, with editing built in to new UI view and code templates and text clips consolidated
3) Multiple concurrent selections (ctrl+select)
4) Type into multiple selections and block selections
5) Virtual space
6) Translations - PN in your language
7) Prototype Command bar for PyPN users, supports customisable modal commands
8) Flexible split views
9) Support for notepad.exe interception via -z (uses Image File Execution options)
10) Numerous small visual tweaks
11) Line padding options - increase visual space between lines for improved readability
12) CTags upgraded to 5.8
13) Converting between ANSI/Unicode properly converts current file contents (#1020, #1021, #1018, #148)
14) New TextUtil extension
15) Improvements to features supported in extensions SDK
16) Explorer menu integration in Options | Integration
17) Vastly improved file encoding options and defaults
18) Strip line endings on save
19) Make sure file ends in blank line
20) Double-click on position brings up Go To dialog
21) Double-click on INS to change to OVR and vice-versa
22) Fixed-width fonts highlighted in Options
23) File exlusions for magic folders
24) Tagging support for batch, basic, matlab, ocaml

Bug Fixes:
----------

This is just a small set of fixes in 2.2 over 2.0.10:

1) Save All now available regardless of current file save state
2) Long line length recalculated better, scrolling improved
3) Scheme command line argument was broken (#899)
4) Cannot autocomplete after cancelling text clip insertion (#857)
5) New default 0 scrollbar width (#897)
6) Assorted autocomplete fixes, should now be more reliable
7) Fixed incorrect calltip display (#792)
8) Fix default style continuation with custom schemes (#890)
9) Remove magic folder if add is cancelled (#868)
10) Minor UI fixes (#869)
11) Fix for slow loading when there are large zip files on the desktop
12) Error in command bar when pressing enter with no text (#842)
13) Menu access via keyboard was broken when focused on a docking window
14) Avoid docking windows being minimised etc. (#776)
15) Problem with file save modifiers (#836)
16) Hidden files can now be saved (#859)
17) Remapped jump to matching brace to Alt-[ to avoid stomping on jump to previous paragraph which is Ctrl-[ (#831)
18) PHP scheme includes $ as a word char
19) Commenting fixed for vbscript scheme
20) Incorrect menu item hints fixed
21) Smart highlight works across whole document (#525)
22) Workspace save now remembers tab order
23) Allow forcing readonly from the command line
24) Various ctags-related crashes fixed
25) Check for updates stability fixes
26) Changing magic folder path works properly (#760)
27) Fix for project case issues (#527)
28) Fixed side-by-side warning for ctagsnavigator (#159)
29) Projects default to case-insensitive sort (#116)
30) Support escaping slashes with regular expressions (#594)
31) Some UTF-16 related fixes (#592)


What's new in 2.2 under the cover?
------------------------------------------

1) Scintilla updated to 2.11
2) Boost updated to 1.42
3) Now built with Visual Studio 2008
4) Code now in Mercurial


Extensions Interface Changes:
-----------------------------

1) Many changes for unicode, all paths are now wchar_t

========================================
Release Name: 2.0.10 - "Dizzy"
Build: 1010
========================================

What's new in 2.0.10?
--------------------

1) Switched to vista-style message dialogs
2) API-based autocomplete, currently supporting Notepad++ format (#142)
3) Updated Scintilla
4) Added new Open Files view
5) Added new File Browser view
6) New icons for docking windows
7) Vastly improved Regular Expressions support, including multi-line expression support
8) Added support for word character set specification in schemes
9) New style presets (ZenBurn, Murky, Turbo)
10) Auto-complete choices are backed by file instead of the registry
11) Goto line highlights the text that was jumped to when using tags
12) Support for folding at "else" added to schemes (see cpp.scheme)
13) Better default caret x positioning behaviour
14) Minor visual improvements
15) Marked as vista-aware, no more VirtualStore problems
16) Automatic update check
17) Go to previous bookmark
18) Switched to vista open/save dialogs on appropriate platforms
19) New SDK
20) New Find in Files option: All Open Files
21) New link to Forums in Help menu (#76)
22) New Move Line Up and Move Line Down commands in Edit|Line (#68)
23) Added readonly toggle to editor window (from Klaus, #83)
24) (re-)Added Mark All
25) Added Clear Bookmarks command (#90)
26) Explorer menus in context menus
27) Improved extension crash debugging (#127)
28) Option to create backups when saving files (#106)
29) New commands for working with current text selection (#245)
30) File changed notification can be disabled for a single file (#214)
31) Text clip editor now uses default scheme (#144)
32) Improved PHP styling with colour presets (#195)
33) Comment commands and text transforms on context menu (#223, #221)
34) Re-use unchanged blank document window when opening a file (#17)
35) Clean up the UI for first run (#211)
36) You can now record scripts (macros) with PyPN
37) Window switching in the order of the tabs now supported (#391)
38) Add find dialog accelerators (#401)
39) Draggable toolbars replaced with one customizable one
40) Find Next and Previous word under cursor (#155)
41) Various improvements to the usability of the open files window (#84)
42) Added Smart Highlight - marks all occurrences of selected word. (#150)
43) Moved Find and related commands into Search menu
44) New remove blank lines command
45) Mini bar can be removed and icons can be placed on customisable toolbar instead (#446)

Bug Fixes:
----------

1) Don't auto-append find text
2) Some message dialogs appear oddly on Win9x
3) Can't use magic folder wizard without C: (SF #1703085)
4) Correctly show toolbar toggles on load (#29)
5) Don't show quickfind bar on toggle of find toolbar
6) Make sure custom line number colouring works for default scheme
7) Minor folding fix
8) Check open files before opening from most recently used
9) Fixed tags parsing where tag includes the dollar sign
10) Find in files extensions can now be separated by space, comma, semicolon
11) Inform the user when they're trying to search with an invalid regex
12) Fix problem with tabs getting hidden
13) Maximum scheme name length ignored when matching schemes to files (#71)
14) OnAfterLoad not called when document first loaded
15) Undo buffer not cleared properly at load and revert (#35)
16) Support forward-slash paths in command-line parameters (#49)
17) When wrapping text, end key goes to the end of the wrap line (#69)
18) Odd behaviour when cancelling removal of unsaved project (SF #1957796)
19) Fixed long line help options
20) Don't change to file directory on open, allows directory deletion
21) Allow "Del" key in keyboard shortcut editor (#45)
22) Hopefully fixed HTML help window positioning (#110)
23) Fixed scheme selection in options dialog (#13)
24) Fix Windows 2000 support (#124)
25) Restore document windows on jumps (#130)
26) Allow opening workspace files again (#25)
27) Fixed Win7 Close Hang
28) Fixed Tab and Space conversion errors (#301)
29) Fixed extended character entry (#48)
30) Project file icon changes when rename changes type (#259)
31) Tool running crash (#250)
32) Launching non-captured console tool disables Ctrl-C (#78)
33) Space can't be entered as a keyboard shortcut (#284)
34) Fix up ascii text clips, and allow insertion of special characters (#274)
35) Cancelling parameters window doesn't cancel tool running (#285)
36) Search hidden files option missing (#229)
37) files are reopened when loading workspaces (#228)
38) Project tools missing from menus (#227)
39) Make sure jumping to a bookmark scrolls into view (#219)
40) Middle click close on updated file causes crash (#203)
41) Workspace re-open prevented by command-line parameters (#288)
42) Global tools selection the default with non-scheme file (#306)
43) Magic folder crash (#257)
44) Project properties don't work from tools
45) Enter to select tag (#374)
46) Project properties dialog resize (#398)
47) BOM validated when loading unicode files (#335)
48) Two replace all infinite loops fixed (#308, #372)
49) Not all matches correct when using Mark All with regex (#366)
50) Toolbar button state managed better (#287)
51) Line up/down commands fixed (#369)
52) Fixes for autocomplete file loading/saving (#384)
53) Focus quick find even if already shown (#392)
54) Text insertion in find combos fixed (#377)
55) Don't save unnecessarily when running tools (#396)
56) .LOG text styling matches notepad (#346)
57) Search dialog gets stuck on Win7 RC (#444)

Extensions Interface Changes:
-----------------------------

1) Split IDocumentEventSink and ITextEditorEventSink (previously you had to implement both)
2) More IDocumentEventSink methods
3) Now supports menu items provided by extensions

========================================
Release Name: 2.0.8.718
Build: 2.0.8.718, Version Label: Basie
========================================

What's new?
-----------

1) Extensions interface
2) Detection of UTF-8 without a Byte Order Mark, also an encoding option (parts by Oleg Gerasimov)
3) Sets unicode character set automatically when a unicode file encoding is selected.
4) Decorators in Python scheme
5) Add New File in Magic Folders context menu
6) Tag browser window (Klaus, Manuel)
7) Full VHDL scheme instead of user scheme (Klaus)
8) VHDL tag support (Klaus)
9) Remove non-existant MRU entries when selected (SF RFE #1469296)
10) Python scripting extension (pypn)
11) New lovely toolbar images courtesy of famfamfam.com
12) Save All toolbar button
13) Keyboard customisation
14) Text clips maintain current indentation (SF Bug #1412316)
15) Default Character Set option for non-unicode language support (experimental)
16) Comment text automatically (scheme support dependant)
17) New tool parameter: ${PNPath} - the path PN is installed in
18) Comment-out code: Edit|Comments|Line or Stream or Block - depending on language support
19) Keyword and tags based autocomplete (Manuel)
20) Cut, copy, paste, undo, redo buttons enabled only when available
21) $(ProjectName) for tools - the active project name (SF RFE #1482915))
22) Find in files auto-locations in drop-down
23) New command-line parameters (see help)
24) Minor master scheme changes
25) Allows you to set scheme properties for all languages in one place (global styles)
26) Scheme changes: Hypertext->HTML, PHP added, PHP Script added
27) New extension points for OnBeforeSave and OnAfterLoad
28) ctags tag provider is now an extension, custom tagger 
   plugin format removed
29) Extension discovery method: run "pn -findexts"
30) Added $(ProjectGroupName) tools property
31) Added Rename shortcut to project context menus (you can already rename using the two clicks convention)
32) Added $(ProjectProp:*) and $(FileProp:*) tools shortcuts, these retrieve values from project item configurations
33) Added alpha settings for line highlight, new default colour to make use of alpha
34) Added option to disable folding
35) New code templates feature (try typing "if" and then Edit->Insert Template in c/c++)
36) Now supports custom ctags tagger definitions (see in taggers\ctags directory)
37) Added Open Containing Folder, Open in Default Folder and Copy File Path to various context menus
38) Text clips now cached in user settings directory to avoid user needing to change files in install path
39) New extensions method pn_get_extension_info
40) New extensions types for passing strings safely with stored allocators

Bug Fixes:
----------

1) Command-line paramters not working (SF Bug #1334272)
2) Control-R doesn't update text in replace window (SF Bug #1360767)
3) Crash on undo after file revert (SF Bug #1371138)
4) Drop down lists too small (SF Bug #1373484)
5) Extension Editbox input error (SF Bug #1358022)
6) Filenames with ampersand (&) (SF Bug #1241368)
7) Sanitise relative path strings in output parser (Oleg Gerasimov)
8) <Enter> key in project window open selected file (Oleg Gerasimov)
9) Opening non-existant file from recent menu, opens new file (SF Bug #1471053)
10) Browse for folder inappriopriately shows New Folder button (SF Bug #1471056)
11) Can't remove file association if text is entered (SF Bug #1463848)
12) Can't use a relative directory path to store PN settings (see config.xml)
13) Drag & drop file into project folder: appears twice (SF Bug #1490889)
14) Bugs with projects window (SF Bug #1330960)
15) "Recent Files" List Not Updated (SF Bug #1377909)
16) Project tools keyboard shortcuts don't work (SF Bug #1422790)
17) Line endings detection didn't work properly for UTF-16 (SF Bug #1480945)
18) Using INI file settings did not store re-load options properly
19) UI settings not stored in INI file when using INI storage
20) Searching back and forward broken (SF Bug #1451538)
21) PN crashes when trying to access non-existent project (SF Bug #1496940)
22) Numbered bookmarks don't work properly (SF Bug #1326469)
23) Global output window flickers when output being added
24) New default magic folder file filter (SF Bug #1371183)
25) Numbered bookmarks don't work properly (SF Bug #1326469)
26) Quick Find Textbox Border Color Problem (SF Bug #1465805)
27) Find bar corruption after documents closed (SF Bug #1361852)
28) BOM present even when 'UTF-8 No mark' selected as encoding (SF Bug #1545264)
29) Can't copy file from magic folder to project properly (SF Bug #1576076)
30) File type edits don't show new value in list.
31) Minor Vista bug fixes
32) Don't reset scheme when saving files with no extension
33) Occasional failure to save settings on exit (particularly with debug builds)
34) Line numbers toggle not updated when default (SF Bug #1729577)
35) File corruption with utf-16 files > 65536 characters (SF Bug #1741342)
36) Some php keywords only being matched in uppercase
37) Tabs/Spaces override changes don't save (SF Bug #1632540)
38) Copy RTF doesn't copy whole file (SF Bug #1802226, Patch #1816866)
39) Add option to save project files before running tools (SF Bug #1679394)
40) Close All leaves tags behind (SF Bug #1834448)
41) .688 spontaneously closes on close-all (SF Bug #1813319)
42) Tags window does not update on save (fix thanks to Klaus)
43) Modified flag gets reset on using jump to


========================================
Release Name: 2.0.6.0
Build: 2.0.6.0, Version Label: ella
========================================

What's new?
-----------

1) Project Properties
2) Editable Magic Folder Properties
3) Ctrl+H for Replace.
4) Right-Click on a file to add to a project.
5) Selected text insertion into find dialog is more selective (no pun intended).
6) Project changed indicator (appends * to name).
7) Project tools.
8) Tab usage option per scheme (SF RFE #1050938).
9) Stack Based Ctrl-Tab Ordering (SF RFE #995790).
10) Browse for folder in find in files dialog.
11) Support for vbc compiler output (SF Bug #1168477).
12) Docbook Scheme
13) Scintilla version 1.6.6
14) CSS-2 Support in CSS lexer
15) Projects remember folder expansion state.
16) Added Ctrl-W to close the current file (as well as Ctrl-F4) (SF RFE #1169428).
17) New Project dialog.
18) Save project from context menu.
19) Refresh magic folder from context menu.
20) Ctrl+[ jumps to matching or nearest brace.
21) Ruby scheme
22) Better behaviour with files opened using relative paths.
23) Wrap text clips around selected text (SF RFE #1199676).
24) Escape key closes find results if no output windows are open.
25) Optionally save workspace between runs ("Remember open files and projects between sessions" in General options).
26) Open to save workspace files from File menu, opening a .pnws file opens the saved workspace.
27) SmartStart applied to opened files.
28) New Incremental FindBar (Press Ctrl+/ and start typing, escape to cancel).
29) Customisable scheme mappings (choose schemes for file types - Options|Files).
30) Find Previous - Shift+F3
31) Support for Java properties files (SF RFE #1267017).
32) Find in Files can ignore hidden files.
33) Remember Selected Text Clips Set (SF RFE #1279158).
34) Press Enter to insert a text clip (SF RFE #1259865).
35) Show textclips in tool tip text (SF RFE #1116510).
36) Add Assembly Scheme (SF RFE #1290453).
37) No more default comic sans for comments in web schemes!
38) Support Ctrl+Shift+[X|V] for VNC cut-paste with caps lock support, Ctrl+Shift+C already taken for clipboard swap.

Bug Fixes:
----------

1) Find in Files gets selected text.
2) Find in selection fixed.
3) Find Next and Replace One no longer supported in "in selection" mode.
4) Find Next replaces selection in find text box when text not found.
5) Switching tabs causes "re-maximization" (SF Bug #1169434).
6) Launch Search Dialog With No Document (SF Bug #1168100).
7) "Allow backslash expressions" does not work in search.
8) Crash on Running Find in Files With Operation in Progress (SF Bug #1168101).
9) code-folding works not correct (SF Bug #1050483).
10) HTML export uses wrong CSS syntax (SF Bug #1074120).
11) Normal Search does not work with UTF-8 (Unicode) chars > 127 (SF Bug #1200456).
12) Relative paths don't work from command-line with single-instance PN (SF Bug #1161783).
13) Window Dimensions After Un-Maximizing (SF Bug #1167299).
14) File -> New Broken (SF Bug #1221755).
15) Don't exit if save is cancelled for a previously unsaved item.
16) Selecting the XML lexer after another does not correctly style.
17) No code-folding for XML (SF Bug #1212335).
18) Keyword customisation causes hang (SF Bug #1209962).
19) Delete Line same as Cut Line (SF Bug #1234653).
20) "Search Up" box not visible for replace.
21) Bad coloring in Text Clips combo box with non-white window colors (SF Bug #1065666).
22) Tried to open a file twice when that file was not found.
23) VHDL Syntax file inclusion (SF Bug #1165830).
24) Crash when adding a project tool (SF Bug #1195786).
25) Show Lines Numbers" setting does not affect open files (SF Bug #1212355).
26) Toggling syntax highlighting looses word wrap (SF Bug #1151704).
27) Undo/Redo in folded area does not unfold (SF Bug #1286210).
28) PN2 is confused by relative path names (SF Bug #1232939).
29) Docking windows resize to tiny (SF Bug #1018105).
30) Sub-windows initialization issue (SF Bug #1065665).
31) Fixed a bug with default styles and the Plain Text scheme.

========================================
Release Name: 2.0.5.6
Build: 2.0.5.34, Version Label: 
========================================

What's new?
-----------

1) Document Properties Window (hit alt-enter).
2) Editor Defaults options page.
3) Default word-wrap option.
4) Most Recently Used Projects menu.
5) HTML export now names the styles by scheme, allowing you to easily 
   combine exported code.
6) Look in projects for relative file names in the output window.
7) Look in the current directory for relative file names in the output window.
8) Added current project path to the tool variables.
9) New (fairly empty) confirmations options page.
10) Drag files from explorer onto the projects window.
11) Upgraded to Scintilla 1.60
12) Project files now written using Genx.
13) Project files keep most unknown XML elements between load and save.
14) Added Duplicate, Copy, Cut and Transpose Line commands.
15) Added Uppercase/Lowercase
16) Bjoern Graf tidied the Options dialog plus some others.
17) Keyboard works in the projects tree (inc. "del" to remove project files).
18) Added error parsing for microsoft error messages.
19) Middle-click mouse on the document tab to close a document.
20) Allow specification of default character set (includes Shift-JIS and UTF-8).
21) Optimised file loading - significantly reduces load time for large files.
22) Drag and drop in the projects window.
23) Folders in project window now remain above files.
24) Drag to re-arrange tabs.
25) Optional new, empty file on startup.
26) Magic Folders in projects - folders that reflect real directory contents.
27) Now open the "open file" dialog in the same directory as the current file.
28) Now shows tool keyboard shortcuts on the tools menu.
19) File association editor.

Bug Fixes:
----------

1)  Empty search on google causes crash (SF Bug #870649).
2)  Change line endings in Save-As dialog doesn't work (SF Bug #885586).
3)  Tools run without capture don't show (SF Bug #896269).
4)  Conflict in shortcut assignment (SF Bug #891208).
5)  Crash if mouse over 'Recent Files'->(empty) (SF Bug #900929).
6)  PN doesn't become active after clicking Output window (SF Bug #760362).
7)  HTML export doubles the '&' (SF Bug #899079).
8)  HTML export leaves open the last span tag (SF Bug #904149).
9)  Fixed HTML export to use full style range (previously stopped at 31).
10) Dropped files always open new windows (SF Bug #873386).
11) Deal with all URL encoded chars in output window, not just %20.
12) Projects window renames too readily.
13) Auto-indent empty line (SF Bug #879950).
14) Can't export a file that isn't saved to disk (SF Bug #911381).
15) Can't bring up project context menus with the keyboard.
16) Changing full path option doesn't affect open files (SF Bug #871628).
17) Update status bar when last file closed (SF Bug #514527).
18) Highlight colors in scheme wrong when choosing defaults (SF Bug #909343).
19) PN loses focus on closing search dialogs (SF Bug #939917).
20) Duplicate brace match colour settings (SF Bug #951146).
21) Esc doesn't close the refresh dialog (SF Bug #939931).
22) Pseudo misspelt in CSS scheme (SF Bug #969586).
23) Regular Expression replace (SF Bug #957788).
24) Global keyboard shortcuts don't work (SF Bug #960000).
25) Fixed file associations case comparison.
26) Text clips line endings (SF Bug #995845).
27) Crash after options dialog (SF Bug #995786).
28) Crash when search string is empty (SF Bug #995783).
29) Fixed infinite loop when working with magic folders containing ".files".
30) Fixed word-wrap default preference.
31) Fixed a problem with checking for updated files with a captured cursor.
32) Fixed a magic folder problem with relative paths.

========================================
Release Name: 2.0.5.0
Build: 2.0.5.18, Version Label: mingus
========================================

What's new?
-----------

1) Scheme-selector toolbar.
2) Find toolbar.
3) Many find improvements (thanks mostly to Bjoern Graf).
4) Tile Vertical / Tile Horizontal.
5) Show path of file to be executed (SF Feature #765270).
6) Visual Help options (highlight current line, long line help).
7) Sanitise file names from output window to better find files.
8) Text clips browser.
9) Projects/Project Groups.
10) Change MRU text length. (SF Feature #760660)
11) Keyboard-shortcuts for Tools.
12) More editor colouring options.
13) Statusbar text on mouse-over MRU items.
14) (X)HTML Export.
15) Added Modula-2 Scheme.
16) Pre-defined toolsets can now be added in the %pn%\tools directory.
17) Updates to the tab and docking frameworks.
18) Added encoding menu.
19) Configurable alternate file switching (use Ctrl-Shift-H to switch).

Bug Fixes:
----------

1) Show Full Path turns off after a revert. (SF Bug #773608)
2) Stop Tools doesn't work. (SF Bug #773294)
3) If you don't update a file when it's changed on disk it is marked as changed.
4) Maximized window state not saved. (SF Bug #770302)
5) Mixed path styles now sanitised in output window. (SF Bug #797397)
6) File opened from the wrong directory from output window. (SF Bug #806343)
7) No way to find out what file you're working on. (SF Bug #783786)
8) NT4 recent files menu disappears. (SF Bug #780828)
9) Edit SmartStart Phrase Dialog no scheme list. (SF Bug #771661)
10) WindowState is not save when close. (SF Bug #770302)
11) Unable to define a shortcut for a custom tool. (SF Bug #753458)
12) Collapse all folds menu item fixed.
13) Italic font customisations not picked up. (SF Bug #834967)
14) Save All only saves unchanged files. (SF Bug #827998)
15) Fixed view->toolbars menu. Now represents correct startup state.
16) Files read as unicode now saved as unicode.
17) Tool Modifies File w/o Capture Output. (SF Bug #799763)
18) Tool Modifies File causes refresh oddness. (SF Bug #800331)
19) Regular Expression loop. (SF Bug #793002)
20) Close when minimized bug. (SF Bug #849572)


========================================
Release Name: 2.0.4.2
Build: 2.0.4.18, Version Label: (none)
========================================

What's new?
-----------

1) Re-organised general options page to clarify.
2) Show full path in title bar option.
3) Save none / one / all files on running a tool.

Bug Fixes:
----------

1) Global output window not toggled properly by running a tool.
2) SF Bug #763393 - files opened at startup do not get tabs.

========================================
Release Name: 2.0.4.1
Build: 2.0.4.14, Version Label: (none)
========================================

Bug Fixes:
----------

1) Global output window flickers when text is added (SF Bugs #760349 and #752839).
2) Tool editor dialog output window selector combo fixed (SF Bug #752826).
3) Line Number display related corruption fixed (SF Bugs #752847 and #753457).
4) Minor UI bug in tool editor (SF Bug #760347).
5) Tools order up button doesn't work correctly (SF Bugs #752831 and #752834).
6) click error in output window and PN2 always opens file (SF Bug #760351).

What's new?
-----------

1) Select All menu item to show availability (SF RFE #754417).
2) Folding keyboard shortcuts shown in menu (SF Bug #760346).

========================================
Release Name: 2.0.4-miles
Build: 2.0.4.14, Version Label: miles
========================================

What's new?
-----------

1) Groups of scheme settings can now be configured using their style group head item.

example: To change the background for all PHP styles, simply change the background
on the main PHP item that contains the styles below it. This will not override any
custom backgrounds already set on those items - those will need to be reset.

2) User-Schemes

Define your own schemes using simple XML - can support a large number of languages. 
See the included vhdl.schemedef sample. There will be documentation for this soon.

3) Tool output parsing for a number of built-in types.
4) Output parsing for user-defined output strings.
5) Matched output jumps to the correct position in the correct file when clicked.
6) Tool editor dialog re-designed (a bit)
7) Docking global output window.
8) Clipboard Swap (Ctrl-Shift-C)

paste clipboard into selection and place selection on the clipboard.

9) Options dialog more keyboard accessible.
10) Maximise on opening.
11) PN remembers its window positioning between loads.
12) Perl scheme.
13) Better pascal scheme.
14) Folding keyboard shortcuts: 

Ctrl-Alt-+ Expand All, Ctrl-Alt-- Collapse All, Ctrl+* toggle current fold block

15) Copy as RTF and export RTF.

16-ish) A Modula-2 scheme will be released separately in a week or two. Some code changes were made to Scintilla for this.

========================================
Release Name: 2.0.3-coltrane
Build: 2.0.3.30, Version Label: coltrane
========================================

Breaking Change Notices:
------------------------
User configuration files have moved from:
%usersettings%\Echo Software\Programmers Notepad\Schemes\
to:
%usersettings%\Echo Software\PN2\

this will lose any scheme colouring changes you have made. 
You can simply move all files from the previous version into
the new correct location to fix this. Sorry for any 
inconvenience...

What's new?
-----------

1) Configurable scheme keywords.
2) Now opens filenames from the command-line (or explorer associations).
3) Tools functionality. Configure from Options->Tools.
4) CSS Scheme now works.
5) Colourised output capturing in tools (configurable in Options->Schemes).
6) C#, JavaScript, Batch, Diff and makefile schemes.
7) Double-click on MDI area to open file.
8) General options page - default editor options.

======================================
Release Name: 2.0.2-simba
Build: 2.0.2.27, Version Label: simba
======================================

This is the second release of Programmers Notepad 2.

What's new?
-----------

1) Options dialog.
2) Printing support.
3) Less bugs.
4) Configurable schemes (through options dialog).
5) Python Scheme

Printing note: This feature is experimental, and we have experienced the odd problem after printing. Please experiment and let us know how you get on.

=======================================
Release Name: 2.0.1-poptart
Build: 2.0.1.32, Version Label: poptart
=======================================

This is the first release of Programmers Notepad 2. Obviously there are a limited number of features at the moment.

Please don't moan about the following, they are all quite obvious to us already:

1) No options dialog.
2) Missing schemes from pn1.
3) No options dialog (incase you missed it above).
4) No project management.
5) No tools.
6) No printing.
7) Toolbars aren't dockable.
8) You can't turn the tabs off.

So what is good?

1) New editing engine (The excellent Scintilla: http://www.scintilla.org/).
2) Now written in C++ using the Windows Template Library.
3) Fast. Really Fast - compare opening times for large files with PN1.
4) Two (count-em!) toolbars. Obviously this sort of stuff will get better as time goes on.
5) Lovely XP-Style tabs.
6) Save-As dialog contains a "File Format" feature.
7) Support for C++, HTML, XML and Object Pascal. More schemes coming soon.
8) Highly configurable XML backend for scheme configuration, config dialog coming to a release near you soon.
9) The minibar from pn1 is here (see at the bottom of the edit windows).
10) Scoping / Folding / Outlining (Open a C++ or Pascal file to see this, it's lovely).
